
/*  Nl2Pb - converts a fidonet non-compiled nodelist to a term phonebook

    (c) Thorsten "Flavour" Stocksmeier.

    If you use this code or just smile about, leave me a note at
    flavour@aventure.teuto.de! :-)

    I adopted some older code, so this does not use those nice error
    handling features Wouter has built into E. (Short time after I wrote
    this, I began looking around for them ;-))

    Original source dates back somewhen in March '96.

*/

MODULE 'dos/dos','exec/memory'

/* variables for some stuff */

DEF src,dest,rdarg,myargs:PTR TO LONG,cnt,mem,next,packet=NIL,bbs,number,x,y,z,
    blurp,len,bum=NIL,pat[30]:STRING,bad=NIL,habschon=NIL,failed=NIL

/* this is the input buffer size. 20kb seems to be an ideal size, my testers
   reported excellent speed results, but if you like to change this, feel free
   to do. */

CONST BUFSIZE=20000

/* simple debugger */

PROC debug(txt)
    IF myargs[3]
        WriteF('\d: \s\n',AvailMem(MEMF_ANY),txt)
    ENDIF
ENDPROC

/* all those nice things are banged into the main procedure... ;-))) */

PROC main()
    mem:=New(BUFSIZE+100)
    myargs:=[0,0,0,0,0]
    IF rdarg:=ReadArgs('NODELIST/A,PHONEBOOK/A,PATTERN/A,DEBUG/S,FORCE/S,REPLACEMENT/A',myargs,NIL)

        debug('debug mode established')

        IF StrLen(myargs[2])<2
            WriteF('Pattern too short. (min. 2 chars)\n')
            JUMP grmbl
        ENDIF

        IF (InStr(myargs[2],'-',NIL)=-1) AND (myargs[4]=0)
            WriteF('WARNING: You specified a pattern without a correct international\n')
            WriteF('phonecode. This may result in phonebooks >=10MB. If you are really\n')
            WriteF('sure you want this, override this warning with the FORCE switch.\n')
            JUMP grmbl
        ENDIF

        StringF(pat,',\s\0',myargs[2])
        debug('calculated search string')
        IF src:=Open(myargs[0],OLDFILE)
            debug('source file (nodelist) opened')
            IF dest:=Open(myargs[1],NEWFILE)
                debug('destination file (phonebook) opened)')
                /* Write an IFF-header per hand... Somehow weird :)) */

                Write(dest,["CAT ",0,"TERM","FORM",$1C,"TERM","VERS",4,$40003,"DIAL",4,9],12*4)
                debug('iff header written')
                len:=12*4

                cnt:=NIL

                WriteF('$VER: Nl2Pb 0.2 (27.6.96) flavour@aventure.teuto.de\n')

                WHILE (Read(src,mem,BUFSIZE))=BUFSIZE
                    PutChar(mem+BUFSIZE,10)

                    REPEAT
                        next:=InStr(mem+cnt,'\n',0)
                        PutChar(mem+cnt+next,0)
                     
                        IF (number:=InStr(mem+cnt,pat,0))<>-1
                            failed:=NIL
                            habschon:=TRUE
                            bad:=NIL
                            number:=number+mem+cnt+1
                            x:=mem+cnt

                            IF StrCmp(mem+cnt,',',1)
                                y:=InStr(mem+cnt+1,',')
                                z:=mem+cnt+y+1
                                PutChar(z+InStr(z+1,',',0)+1,0)

                                x:=InStr(number+1,',',0)
                                PutChar(number+1+x,0)
                                number:=number+3

                                linedel()
                                WriteF('Found \l\s (\s\s) \c',z+1,myargs[5],number,13)

                                Write(dest,["FORM",$202],8)
                                Write(dest,'TERMPHON',8)
                                Write(dest,[$1BA],4)

                                IF blurp:=New(442)
                                    len:=len+462
                                    CopyMem(z+1,blurp,IF StrLen(z+1)>29 THEN 29 ELSE StrLen(z+1))
                                    StringF(blurp+40,'\s',myargs[5])
                                    CopyMem(number,blurp+40+StrLen(myargs[5]),IF StrLen(number)>28 THEN 28 ELSE StrLen(number))

                                    Write(dest,blurp,442)
                                    INC bum

                                    Dispose(blurp)
                                ELSE
                                  WriteF('Could not allocate 442 bytes.\n')
                                  JUMP exit
                                ENDIF


                                Write(dest,'DATE',4)
                                Write(dest,[$34],4)
                                Write(dest,[0,0,0,0,0,$FFFF,2,0,0,$30000000,$20000,0,$6C00],13*4)
                                len:=len+(15*4)

                            ELSE
                                linedel()
                                WriteF('no "," at beginning of line, skipping (\d)\c',cnt,13)
                            ENDIF
                        ELSE
                            INC failed
                            IF (bad++)=0
                                
                                linedel()
                                WriteF('no international phone code match, skipping\c',13)

                            ENDIF
                        ENDIF

                        cnt:=cnt+next+1
                        IF CtrlC() THEN JUMP exit
                    UNTIL (cnt>BUFSIZE) OR (CtrlC())
                    INC packet
                    /* IF packet=50 THEN JUMP exit */
                    cnt:=NIL
                ENDWHILE

                linedel()
                WriteF('\n\n Converted \d matching BBSs\n',bum)
                

exit:
                debug('seeking back to beginning of iff')
                Seek(dest,4,OFFSET_BEGINNING)
                Write(dest,[len],4)
                Seek(dest,$2C,OFFSET_BEGINNING)
                Write(dest,[bum],4)
                debug('new length written')
                Close(dest)
                debug('destination (phonebook) closed')
                IF len>100000
                    WriteF('\n\nWarning: Phonebook filesize exceeds 100kb. Term will\nhave to use a lot of memory to read it in.\nBe careful! Term\as phonebook parser is\nnot guru safe! ;-)\n')
                ENDIF
            ELSE
                WriteF('Could not open new phonebook file.\n')
            ENDIF
            Close(src)
            debug('source (nodelist) closed')
        ELSE
            WriteF('Could not open nodelist.\n')
        ENDIF
grmbl:
        FreeArgs(rdarg)
        debug('arg header freed')
    ELSE
        WriteF('bad args.\n')
    ENDIF
ENDPROC

/* crap to send an ANSI-DelLine-character to the output shell/file */

PROC linedel() IS WriteF('\cK',$9B)
